#!/usr/bin/env python
import string
from isstring import isstring
from public import public

__all__ = ["printable"]

printable = string.printable


@public
def getprintable(string, replace=""):
    result = []
    if not isstring(string):
        string = str(string)
    for s in string:
        try:
            if s in string.printable:
                result.append(s)
            else:
                result.append(replace)
        except Exception:
            pass
    return type(string)("".join(result))
